#!/usr/bin/perl
package My_Parse_DVI;
	#$charwidth=My_Parse_DVI::round My_Parse_DVI::mypost($filetoparse),80;
use TeX::DVI::Parse;
@ISA = qw( TeX::DVI::Parse);
use line;
sub start {
	my (@ARGV) = @_;

	$filetoparse="";
	$orig=0;
	getoptions(@ARGV);
	printoptions();
	#if (! -e $filetoparse) { die "soubor $filetoparse neexistuje\n"; }
	my $app = new My_Parse_DVI ($filetoparse);
	line::load_hyphen($hpatterns);
	$pagecount=0;
	print STDERR "file $filetoparse\n";
	$app->parse();
	print STDERR "That's all folks\n";
}
sub set_char
	{
	my ($self, $ord, $char) = @_;
	$h=$line[$l]->addchar($char,$h,$charwidth);
	$h+=$charwidth;
	}
sub set_rule
	{
	my ($self, $ord, $height, $width) = @_;
	for ($i=0;$i<$width/$charwidth;$i++) {
	$h=$line[$l]->addchar(ord '-',$h,$charwidth);
	#$h+=$charwidth;
	}
	#$v+=$height;
	}
sub put_char
	{
	my ($self, $ord, $char) = @_;
	$line[$l]->addchar($char,$h,$charwidth);
	}
sub put_rule
	{
	my ($self, $ord, $height, $width) = @_;
	for ($i=0;$i<$width/$charwidth;$i++) {
	if ($heiht>$lineheight/2) {$line[$l]->addchar(ord '-',$h,$charwidth); }
	else {$line[$l]->addchar(ord '-',$h,$charwidth);}
	}
	#$v+=$height;
	}
sub nop
	{ my ($self, $ord) = @_; 
	}
sub bop
	{
	my ($self, $ord, @numbers) = @_;
	$pagecount++;
	print STDERR "page $pagecount ...";
	}

#sub eop
#	{ 
#	my ($self, $ord) = @_; 
#	print STDERR "Parsing of page $pagecount finished ...\n";
#	my $curline=$minline;
#	for (my $i=$curline;$i<=$countline;$i++) {
#	if ($orig==1) { $k=$line[$curline]->printl($k); }
#	else { $k=$line[$curline]->printline($k); }
#	my $foo=$curline;
#	$curline=$line[$curline]->{'next'};
#	undef ($line[$foo]);
#	}
#	$minline=20;
#	$countline=20;
#	}

sub eop
	{ 
	my ($self, $ord) = @_; 
	print STDERR " finished ...\n";
	my $curline=$minline;
	while (defined $line[$curline]) {
	if ($orig==1) { $k=$line[$curline]->printl($k); }
	else { $k=$line[$curline]->printline($k);}
	my $foo=$curline;
	#print STDERR "Printing line $curline\n";
	$curline=$line[$curline]->{'next'};
	#print STDERR "Next is $curline\n";
	undef ($line[$foo]);
	}
	$minline=20;
	$countline=19;
	}

sub push
	{ my ($self, $ord) = @_; 
        push @STACK,$h;
        push @STACK,$v;
        push @STACK,$x;
        push @STACK,$y;
        push @STACK,$w;
        push @STACK,$z;
	}
sub pop
	{ my ($self, $ord) = @_; 
        $z=pop @STACK;
        $w=pop @STACK;
        $y=pop @STACK;
        $x=pop @STACK;
        $v=pop @STACK;
        $h=pop @STACK;
	}
sub right
	{ my ($self, $ord, $value) = @_; 
	$r=$value  if defined $value;
	$h+=hmove($r);
	}
sub move_w
	{
	my ($self, $ord, $value) = @_;
        $w = $value if defined $value;
	$h+=hmove($w);
	}
sub move_x
	{
	my ($self, $ord, $value) = @_;
        $x = $value if defined $value;
	$h+=hmove($x);
	}
sub down
	{
	my ($self, $ord, $value) = @_;
	$v += $value;
	$l=findline();
	}
sub move_y
	{
	my ($self, $ord, $value) = @_;
	$y = $value if defined $value;
        $v += $y;
	$l=findline();
	}
sub move_z
	{
	my ($self, $ord, $value) = @_;
        $z = $value if defined $value;
        $v += $value;
	$l=findline();
	}
sub fnt_num
	{
	my ($self, $ord, $k) = @_;
	#print STDERR "Cislo fnt $k, num $fnt[$k]\n";
	if ($curfont == $fnt[$k]){ return 0;}
	if (defined $curfont) {
$line[$l]->addchar(ord '~',$h,$charwidth);
	if ($curfont==0) {$line[$l]->addchar(ord '!',$h,$charwidth);}
	if ($curfont==1) {$line[$l]->addchar(ord '@',$h,$charwidth);}
	if ($curfont==2) {$line[$l]->addchar(ord '#',$h,$charwidth);}
	if ($curfont==3) {$line[$l]->addchar(ord '$',$h,$charwidth);}
	if ($curfont==4) {$line[$l]->addchar(ord '%',$h,$charwidth);}
	}
	if ($fnt[$k]==0) {$line[$l]->addchar(ord '!',$h,$charwidth);}
	if ($fnt[$k]==1) {$line[$l]->addchar(ord '@',$h,$charwidth);}
	if ($fnt[$k]==2) {$line[$l]->addchar(ord '#',$h,$charwidth);}
	if ($fnt[$k]==3) {$line[$l]->addchar(ord '$',$h,$charwidth);}
	if ($fnt[$k]==4) {$line[$l]->addchar(ord '%',$h,$charwidth);}
	if (!defined $fnt[$k]) { print STDERR "Undefinded font number $k\n";}

	$curfont=$fnt[$k];
	}
sub special
	{
	my ($self, $ord, $len, $text) = @_;
	print STDERR "Special character\n";
	}
sub fnt_def
	{
	my ($self, $ord, $k, $c, $s, $d, $a, $l, $name) = @_;
	#print STDERR "Jmeno fontu -- $name   Cislo $k\n";
	if ($name =~ /^..i.*$/)  { $fnt[$k]=0;} #italikaa
	if ($name =~ /^..b.*$/)  { $fnt[$k]=1;} #bold
	if ($name =~ /^..r.*$/)  { $fnt[$k]=2;} #bold
	if ($name =~ /^..t.*$/)  { $fnt[$k]=3;} #bold
	if ($name =~ /^..s.*$/)  { $fnt[$k]=4;} #bold
	}
sub preamble
	{
	my ($self, $ord, $i, $num, $den, $mag, $k, $text) = @_;
	}
sub post
	{
	my ($self, $ord, $prev, $num, $den, $mag, $l, $u, $s, $t) = @_;
	}
sub post_post
	{
	my ($self, $ord, $q, $i, $rest) = @_;
	}
sub undefined_command
	{
	}

sub findline {
	if (!defined $line[$minline]) {          #prvni radek
		$line[$minline]=new line($v);
		}

	if ($v<=$line[$minline]->{'v'}) { 
		$minline--; 
		$line[$minline]=new line($v);		#novy radek pred 1.
		$line[$minline]->{'next'}=$minline+1;
		$line[$minline+1]->{'prev'}=$minline;
		return $minline;
		}
	if ($v>=$line[$countline->{'v'}]) {
		$countline++;			#novy radek za posledni
		$line[$countline]=new line($v);
		$line[$countline]->{'prev'}=$countline-1;
		$line[$countline-1]->{'next'}=$countline;
		return $countline;
		}
	my $foo=$countline;
	while ($line[$foo]->{'v'} > $v && $foo != $minline) {
	  $foo--;			#radek mezi 2 radky
	  }
	  my $topd=$v-$line[$foo]->{'v'};
	  my $botd=$line[$foo+1]->{'v'} - $v;
	  if (($topd < 450000)||($botd<450000)) {
	   if ($topd < $botd) { return $foo; }
	   else {return $foo+1; }
	   }
	   $countline++;
	   my $newline=$countline;
	   $line[$newline]=new line($v);
	   $line[$newline]->{'prev'}=$foo;
	   $line[$newline]->{'next'}=$line[$foo]->{'next'};
	   my $nextfoo=$line[$foo]->{'next'};
	   $line[$nextfoo]->{'prev'}=$newline;
	   $line[$foo]->{'next'}=$newline;
	   return $newline;
	  }
		
		

sub hmove {
	my ($move) = @_;
	if (abs($move) > $charwidth/4) {
	$foo = 3*$charwidth / 4;
	if ($move > 0) {
            $move = ($move+$foo)/$charwidth*$charwidth ;}
	else { $move = ($move-$foo)/$charwidth*$charwidth;}
	return $move;
	}
	else { return 0; }
}
sub round {
	my ($cit,$jm) = @_;
	my $zbytek=$cit%$jm;
	my $res=($cit-$zbytek)/$jm;
	my $resdel=($cit/$jm)-$res;
	if ($resdel>=0.5) {$res++; return $res;}
	else {return $res; }
	}

sub trunc {
	my ($cit,$jm) = @_;
	print "jm -$jm";
	my $zbytek=$cit%$jm;
	my $res=($cit-$zbytek)/$jm;
	my $resdel=($cit/$jm)-$res;
	return $res;
	}

sub makenum {
   my $iter=shift;
   $iter--;
   while ($iter >= 0 ) {
        $dig = shift;
        $result+=$dig*256**$iter;
        $iter--;
	        }
        return $result;
	}

sub mypost {
	my ($filename) = @_;
	open (FILE,$filename) or die "Chyba pri otevirani souboru $filename\n";
	seek FILE,-1,2;
	do {
		read FILE,$trail,1;
		seek FILE,-2,1;
		} while (ord $trail==223);
	seek FILE,1,1;
	seek(FILE,-4,1);
	$arr[0]=4;
	for ($i=1;$i<5;$i++) { read FILE,$dig,1 ; $arr[$i]=ord $dig; }
	$postloc=makenum @arr;
	seek(FILE,$postloc+21,0);
	$arr[0]=4;
	for ($i=1;$i<5;$i++) { read(FILE,$dig,1);$arr[$i]=ord $dig; }
	$maxpagewidth=makenum @arr;
	close FILE;
	return $maxpagewidth;
	}

	sub getoptions {
	my (@ARGV)=@_;
		my $argc=0;
		print STDERR "Options ...\n";
		while (defined $ARGV[$argc]) {$argc++;}
		for (my $i=0;$i<$argc;$i++) {
			if ($ARGV[$i]=~ /-h/) { $hpatterns=$ARGV[$i+1];$i++;}
			if ($ARGV[$i]=~ /-o/) { $orig=1;}
			}
			#DVI soubor
			$filetoparse=$ARGV[$argc-1];
			#Sirka znaku
			$charwidth=mypost($filetoparse)/80;
			
			$h=$v=$x=$y=$w=$z=0;
			$countline=19;
			$k=0;$l=0;
			$pagecount=0;
			$minline=20;
			$lineheight=450000;
			return argc-1;
		}
	sub printoptions {
		select STDERR;
			print "DVI file $filetoparse\n";
			print "Hyphenation patterns file $hpatterns\n";
			if ($orig==1) { print "Printing original\n"; }
				else { print "Printing to braille\n"; }
		select STDOUT;
			}
	
